// ****** Forecast ******

function Forecast() {
}

Forecast.getDataUrl = function() {    
    return dataServerUrl + "wxdata/df/" + settings.locId +".js?&key=" + apiKey + "&day=0,1&cb=?";
}

Forecast.getTodaySiteUrl = function() {
    return "http://MACdbWidget.weather.com/weather/wxdetail/" + settings.locId + 
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=today-detail&par=MACDBv2.0.0&site=widgetfcast";
}

Forecast.getTonightSiteUrl = function() {
    return "http://MACdbWidget.weather.com/weather/wxdetail/" + settings.locId + 
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=tonight-detail&par=MACDBv2.0.0&site=widgetfcast";
}

Forecast.getTomorrowSiteUrl = function() {
    return "http://MACdbWidget.weather.com/weather/wxdetail/" + settings.locId + 
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=tomorrow-detail&par=MACDBv2.0.0&site=widgetfcast"
}

Forecast.getTomorrowNightSiteUrl = function() {
    return "http://MACdbWidget.weather.com/weather/wxdetail/" + settings.locId + 
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=tomnight-detail&par=MACDBv2.0.0&site=widgetfcast"
}

Forecast.getHourlyUrl = function() {
    return "http://MACdbWidget.weather.com/weather/hourbyhour/graph/" + settings.locId + 
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=wx-hourly&par=MACDBv2.0.0&site=widgetfcast";
}

Forecast.get10DaysUrl = function() {
    return "http://MACdbWidget.weather.com/weather/tenday/" + settings.locId +
           "?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetfcast&cm_ite=wx-10day&par=MACDBv2.0.0&site=widgetfcast";
}

Forecast.prototype.update = function() {
    var url = Forecast.getDataUrl();
    $.getJSON(url, function( data ) {
        weatherData.Forecast.show(data);
    });
}

Forecast.prototype.show = function(data){
    if(data.length == 2)
    {
        var tomorrow = getTomorrowDay(false);
        if(data[0].day && data[0].night)
        {
            //Forecast must be Today/Tonight/Tomorrow
            setIcon('imgForecast1', '45', data[0].day.icon, data[0].day.phrase);
            setIcon('imgForecast2', '45', data[0].night.icon, data[0].night.phrase);
            setIcon('imgForecast3', '45', data[1].day.icon, data[1].day.phrase);
            
            $('#divForecast1').text("TODAY");
            $('#divForecast2').text("TONIGHT");
            $('#divForecast3').text(tomorrow);
            
            $('#forecastTemp1').text(getTemp(data[0].maxTemp)); 
            $('#forecastTemp2').text(getTemp(data[0].minTemp));
            $('#forecastTemp3').text(getTemp(data[1].maxTemp));            
            
            setLink('lnkForecast1', Forecast.getTodaySiteUrl());
            setLink('lnkForecast2', Forecast.getTonightSiteUrl());
            setLink('lnkForecast3', Forecast.getTomorrowSiteUrl());
        }
        else
        {            
            //Forecast must be Tonight/Tomorrow/Tomorrow Night
            setIcon('imgForecast1', '45', data[0].night.icon, data[0].night.phrase);
            setIcon('imgForecast2', '45', data[1].day.icon, data[1].day.phrase);
            setIcon('imgForecast3', '45', data[1].night.icon, data[1].night.phrase);
            
            $('#divForecast1').text("TONIGHT");
            $('#divForecast2').text(tomorrow);
            $('#divForecast3').text(getTomorrowDay(true) + " NIGHT");
            
            $('#forecastTemp1').text(getTemp(data[0].minTemp));
            $('#forecastTemp2').text(getTemp(data[1].maxTemp));
            $('#forecastTemp3').text(getTemp(data[1].minTemp));
            
            setLink('lnkForecast1', Forecast.getTonightSiteUrl());
            setLink('lnkForecast2', Forecast.getTomorrowSiteUrl());
            setLink('lnkForecast3', Forecast.getTomorrowNightSiteUrl());
        }
        
        //Buttons
        setLink('lnk10day', Forecast.get10DaysUrl());
        setLink('lnkHourly', Forecast.getHourlyUrl());
    }
}