function findTextContent(xmlDoc, xPath) {
	var ui = xmlDoc.getElementsByTagName("id")[0].childNodes[0].nodeValue;
    return ui;
}


// ****** Settings ******
function Settings() { 
    this.locId = "";
    this.unit = "";   
    this.uniqueId = ""; 
}

Settings.prototype.saveSettings = function(e) {
    this.locId = isNaN ($('#txtSearch').val()) ? $('#locId').val() : $('#txtSearch').val();
    this.unit = $('#select').val();
    var url = weatherData.getLocUrl(this.locId);
    $.getJSON(url, function( data ) {
        settings.Validate(data, e);
    });    
}

Settings.prototype.getDataUrl = function(query, maxResults) {
    return dataServerUrl + 'wxdata/ta/' + query + '.js?key='+ apiKey + '&max=' + maxResults + '&cb=?';
}

Settings.prototype.search = function(query) {
    var url = this.getDataUrl(query, 10);
    $.getJSON(url, function( data ) {
        settings.showResults(data.results, query);
    });
}

Settings.prototype.Validate = function(data, e) {
    var search = trim($('#txtSearch').val());
    var isValid = (search == data.name + ', ' + data.state || 
                   search == data.name + ', ' +  data.country || 
                   search == data.zip)
    
    if(isValid)
    {
        if(this.isFirstTime()){
            sendMessage(msgDownloadCompleted);
            sendMessage(msgAutomaticAppConfig);
        }
        sendMessage(msgDisplayCurrConditions);
            
        this.save();
        weatherData.updateInfo();
        showFront(e);
    }
    else 
    {
       $('#txtSearch').css("color","#003399");
       $("#txtSearch").val(invalidLocText);
    }
}

var $ac;

Settings.prototype.showResults = function(data, query) {
return;
    var suggestions = [];
    var values = [];
    var stateOrCountry = "";
    
    for(i = 0; i < data.length; i++)
    {
        var key = "";
        if(data[i].type == 1 || data[i].type == 4) key = data[i].key;
        else key = data[i].key + ":" + data[i].type;        
            
        stateOrCountry = (data[i].country == 'US') ? data[i].state : data[i].countryName;
        suggestions.push(data[i].name + ', ' + stateOrCountry);
        values.push(key);
    }

    var lookup = { suggestions : suggestions, data : values }
    var options = { lookup: lookup, onSelect: function(value, data){ $('#locId').val(data); $('#txtSearch').focus();  } };
                
    if($ac)
        $ac.setOptions(options);
    else
        $ac = $('#txtSearch').autocomplete(options);
}

Settings.prototype.save = function() {
   if (window.widget) {         
      widget.setPreferenceForKey(this.locId, "locId");
      widget.setPreferenceForKey(this.unit, "unit");
   }
}

Settings.prototype.restore = function() {
    if (window.widget) {
        if (widget.preferenceForKey("locId"))
            this.locId = widget.preferenceForKey("locId");
        if (widget.preferenceForKey("unit"))
            this.unit = widget.preferenceForKey("unit");
        if (widget.preferenceForKey("uniqueId"))
            this.uniqueId = widget.preferenceForKey("uniqueId");
            
        if(this.unit != "") 
            $("#select").val(this.unit);
        
        $("#locId").val(this.locId);
    }
    
    return !this.isFirstTime();
}

Settings.prototype.cancel = function(){
    var url = weatherData.getLocUrl(settings.locId);
    $.getJSON(url, function( data ) {        
        Settings.prototype.setCityData(data);
    });
}

Settings.prototype.setCityData = function(data){
    var city = data.name;
    var stateOrCountry = (data.countryCode == 'US') ? data.state : data.country;
    var zipCode = (showZipCode()) ? '(' + data.zip + ')' : "";
    
    if (!showZipCode())
        $('#txtSearch').val(city + ', ' + stateOrCountry);
    else
        $('#txtSearch').val(data.zip);
     
    $('#select').val(settings.unit);
    $('#txtSearch').css("color","black");
}

Settings.prototype.isFirstTime = function() {
	if(window.widget)
	   return (widget.preferenceForKey("locId") == undefined);
	
	return true; 
}

Settings.prototype.setUniqueId = function() {
    $.ajax({   
            type: "GET",
            url: "http://auth.weather.com/ursa/xml/desktop/installId",
            dataType: "xml",
	    async: false,
            success: function(xmlDoc) {
		this.uniqueId = findTextContent(xmlDoc,"/installid/id");
		if(window.widget) widget.setPreferenceForKey(this.uniqueId, "uniqueId");
		
        }
    }); 
}

