// ****** WeatherData ******
var apiKey = 'e88d0a84-a740-102c-bafd-001321203584';
var dataServerUrl = 'http://wxdata.weather.com/';
var invalidLocText = 'Invalid Location';
var enterCityText = 'Enter ZIP or US / World City';

//Message Variables
var msgDownloadInitiated = 0 ; //First time app launches
var msgDownloadCompleted = 1;  //First time app launches & first download
var msgAutomaticAppConfig = 2; //Every 24 hours while the widget is active 
var msgDisplayCurrConditions = 3; //Display current conditions
var msgDisplayForecast = 4; //Display forecast
var msgDisplayRadar = 5; //Display radar

var weatherData = new WeatherData();
var settings = new Settings();

var totalMin = 0; //total de minutos
var visibleFcst = false;
var visibleRadar = false;

// ****** Objects ******

function WeatherData() {
    this.Forecast = new Forecast();    
    this.Alerts = new Alerts();
    this.Radar = new Radar();
    this.CurrentConditions = new CurrentConditions();    
}

WeatherData.prototype.Init = function() {    
   var today = new Date();    
   $('#currentYear').text(today.getFullYear());
    
    if(window.widget)
	widget.onremove = removeWidget;

   //Hack for safari 2.0
  if(isSafari2())
	{
		$('#info').css('left', 12);
		$('#forecast').css('left', 30);
		$('#radar').css('left', 88);

	}


    if(isTiger())
    {
	$('#currentIcon').hide();
	$('#imgCurrentCond').show();
    }
    else
   {
	$('#currentIcon').show();
	$('#imgCurrentCond').hide();
   }

   //Autosuggest
   var options = {
   script: function (input) { return settings.getDataUrl(document.getElementById('txtSearch').value, 15); },
   varname: "locId",
   json: true,
   maxresults: 15,
   shownoresults:false,
   callback:setLocId,
   minchars:3  
    };
    var as = new bsn.AutoSuggest('txtSearch', options);
	
    //Update every 10 minutes
    alert("start interval...");
    window.setInterval("weatherData.updateInfo()", 600000); 
   
    if (!settings.restore()) 
    {
        settings.setUniqueId();
        sendMessage(msgDownloadInitiated);
        showBack();
        return;
    }

    sendMessage(msgDisplayCurrConditions);
    this.updateInfo();
   
    showFront();
}

WeatherData.prototype.updateInfo = function(){
    if (settings.locId != "") {
        alert("updating...");
        //Update info periodically...  
        this.CurrentConditions.update();
        this.Forecast.update();
        this.Alerts.update();
        this.Radar.update();
        
        totalMin = totalMin + 10;
        if(totalMin == 1440) //24 hs
        {
            sendMessage(msgAutomaticAppConfig);
            totalMin = 0;
        }
        
        if(visibleFcst) 
            sendMessage(msgDisplayForecast);
        if(visibleRadar) 
            sendMessage(msgDisplayRadar);
    }
}

WeatherData.prototype.getLocUrl = function() {
    return dataServerUrl + 'wxdata/loc/' + settings.locId + '.js?key='+ apiKey + "&cb=?";
}

WeatherData.prototype.getWeatherDataLink = function() {
    return 'http://MACdbWidget.weather.com/weather/local/' + settings.locId + 
           'cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetcc&cm_ite=wx-cc&par=MACDBv2.0.0&site=widgetcc';
}

WeatherData.prototype.getWeatherLogoLink = function() {
    return 'http://MACdbWidget.weather.com/?cm_ven=MAC&cm_cat=DBv2.0.0&cm_pla=widgetlogo' 
           '&cm_ite=wx-homepg&par=MACDBv2.0.0&site=widgetlogo';
}